import pygame
import random
import math

pygame.init()
clock = pygame.time.Clock()
SCREEN_WIDTH = 800
SCREEN_HEIGHT = 600
BACKGROUND_COLOR = (255, 255, 255)
screen = pygame.display.set_mode((SCREEN_WIDTH, SCREEN_HEIGHT))
pygame.display.set_caption("Shoot Game")


class Bullet:
    def __init__(self, x, y, angle, color):
        self.x = x
        self.y = y
        self.angle = angle
        self.speed = 20
        self.color = color
        self.radius = 5

    def move(self):
        self.x += self.speed * math.cos(self.angle)
        self.y += self.speed * math.sin(self.angle)

    def draw(self):
        pygame.draw.circle(screen, self.color, (int(self.x), int(self.y)), self.radius)

class Cannon:
    def __init__(self):
        self.x = SCREEN_WIDTH / 2       #800
        self.y = SCREEN_HEIGHT / 2+280  #600
        self.angle = 0
        self.color = (0, 0, 255)
        self.width = 20
        self.height = 20
        self.mouse_pos = (self.x, self.y)

    def aim(self):
        self.mouse_pos = pygame.mouse.get_pos()
        self.angle = math.atan2(self.mouse_pos[1] - self.y, self.mouse_pos[0] - self.x)

    def draw(self):
        pygame.draw.rect(screen, self.color, (self.x - self.width / 2, self.y - self.height / 2, self.width, self.height))
        pygame.draw.line(screen, self.color, (self.x, self.y), (self.x + self.width / 2 * math.cos(self.angle), self.y + self.width / 2 * math.sin(self.angle)), 5)
class Ball:
    def __init__(self):
        self.x = random.randint(0, SCREEN_WIDTH)
        self.y = 0
        self.speed = random.random()*1+0.5
        self.color = (random.randint(0, 255), random.randint(0, 255), random.randint(0, 255))
        self.radius = random.randint(20, 80)
        self.broken = False

    def update(self):
        self.y += self.speed
        if self.y > SCREEN_HEIGHT:
            self.broken = True
    def draw(self):
        pygame.draw.circle(screen, self.color, (self.x, self.y), self.radius)

cannon = Cannon()
bullets = []
balls = []
continuous_fire = False
Continue_Div=0
LastAngle=0
while True:
    angle=-999
    screen.fill(BACKGROUND_COLOR)

    if angle!=-999:
        LastAngle=angle

    mouse_pos = pygame.mouse.get_pos()[1]
    pygame.draw.line(screen, (240, 0, 0), (cannon.x, cannon.y), (pygame.mouse.get_pos()[0], pygame.mouse.get_pos()[1]))

    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            # sys.exit()
        elif event.type == pygame.MOUSEBUTTONDOWN and event.button == 1:

            bullet = Bullet(cannon.x, cannon.y, cannon.angle, cannon.color)

            bullets.append(bullet)
            cannon.color = (random.randint(0, 255), random.randint(0, 255), random.randint(0, 255))
        elif event.type == pygame.MOUSEBUTTONDOWN and event.button == 3:
            continuous_fire = True
        elif event.type == pygame.MOUSEBUTTONUP and event.button == 3:
            continuous_fire = False

    cannon.aim()
    cannon.draw()

    if continuous_fire:
        Continue_Div+=1
        if Continue_Div>2:
            Continue_Div=0

            bullet = Bullet(cannon.x, cannon.y, cannon.angle, cannon.color)

            bullets.append(bullet)
            cannon.color = (random.randint(0, 255), random.randint(0, 255), random.randint(0, 255))

    for bullet in bullets:
        bullet.move()
        if bullet.x < 1 or bullet.x > SCREEN_WIDTH or bullet.y < 0 or bullet.y > SCREEN_HEIGHT:
            bullets.remove(bullet)
            continue        #这里必须有continue，否则Remove后下面继续执行draw也能正常执行，就是列表虽然删除，也可以寻址拿出来，居然没有报错【大坑大坑】
        # if bullet.x < 1:           #【Bug??】 符合条件也没有remove，看是哪里问题
        #     print(bullet.x)
        #     bullets.remove(bullet)
        # if(bullet.x>0):
        #     bullet.draw()
        bullet.draw()

        for ball in balls:
            if ball.y>SCREEN_HEIGHT:
                balls.remove(ball)
            rect = pygame.Rect(ball.x-ball.radius, ball.y-ball.radius, ball.radius*2, ball.radius*2)
            if rect.collidepoint(bullet.x,bullet.y):        #collidecircle  colliderect
                # print("Hit !")
                bullets.remove(bullet)
                ball.radius-=5
                if ball.radius<10:
                    balls.remove(ball)
                break
    # 更新小球状态
    for ball in balls:
        ball.update()
    # 生成新的小球
    if random.randint(0, 100) < 1:
        balls.append(Ball())
    for ball in balls:
        ball.draw()

    clock.tick(60)
    pygame.display.update()